enchant();
window.onload = function() {
    //Core object creation
    var game = new Core(320, 320);
    game.fps = 16;

    //Image loading
    game.preload('http://enchantjs.com/assets/images/bg/bg01.jpg',
        'http://enchantjs.com/assets/images/bg/bg02.jpg',
        'http://enchantjs.com/assets/images/bg/bg03.jpg');

    //Called when pre-loading is complete
    game.onload = function() {
        
        //Background creation
        var bg = makeBackground(game.assets['http://enchantjs.com/assets/images/bg/bg01.jpg'])
        game.rootScene.addChild(bg);
        
        //Message creation
        game.rootScene.addChild(makeMessage("This is the root scene."));
        
        //Choice button creation
        var select=makeSelect("【Move to Scene 1】", 320 - 32 * 2);
        select.addEventListener(Event.TOUCH_START, function(e) {
            game.pushScene(game.makeScene1());
        });
        game.rootScene.addChild(select);
    };
    
    //Scene 1 creation
    game.makeScene1 = function() {
        var scene = new Scene();
        
        //Background creation
        var bg = makeBackground(game.assets['http://enchantjs.com/assets/images/bg/bg02.jpg'])
        scene.addChild(bg);
        
        //Message creation
        scene.addChild(makeMessage("This is Scene 1."));
        
        //Choice button creation
        var select = makeSelect("【Move to Scene 2】", 320 - 32 * 2);
        select.addEventListener(Event.TOUCH_START, function(e) {
            game.pushScene(game.makeScene2());            
        });
        scene.addChild(select);
        scene.addChild(makeReturn(1));
        return scene;
    };
    
    //Scene 2 creation
    game.makeScene2 = function() {
        var scene = new Scene();
        
        //Background creation
        var bg = makeBackground(game.assets['http://enchantjs.com/assets/images/bg/bg03.jpg'])
        scene.addChild(bg);
        
        //Label creation
        scene.addChild(makeMessage("This is Scene 2."));
        scene.addChild(makeReturn(0));
        return scene;
    };
    
    //Start game
    game.start();
};

//Background creation
function makeBackground(image) {
    var bg = new Sprite(320, 320);
    bg.image = image;
    return bg;
}
//Message creation
function makeMessage(text) {
    var label = new Label(text);
    label.font  = "16px monospace";
    label.color = "rgb(255,255,255)";
    label.backgroundColor = "rgba(0,0,0,0.6)";
    label.y     = 320 - 32 * 3;
    label.width = 320;
    label.height = 32 * 3;
    return label;
}

//Choice button creation
function makeSelect(text, y) {
    var label = new Label(text);
    label.font  = "16px monospace";
    label.color = "rgb(255,200,0)";
    label.y     = y;
    label.width = 320;
    return label;
}

//Return button creation
function makeReturn(lineNumber) {
    var game = enchant.Game.instance;
    var returnLabel = makeSelect("【Return】", 320 - 32 * (2-lineNumber));
    returnLabel.addEventListener(Event.TOUCH_START, function(e) {
        game.popScene();
    });
    return returnLabel;
}
